import { OnInit, OnDestroy, ElementRef, ComponentFactoryResolver, ViewContainerRef } from '@angular/core';
import { ISuperTableFilter, ColumnState } from './interfaces';
import { SuperTableState } from './SuperTableState';
export declare class EnumFilterDropdown implements OnInit, OnDestroy {
    private state;
    private el;
    column: ColumnState;
    top: number;
    left: number;
    width: number;
    destroyMe: Function;
    constructor(state: SuperTableState, el: ElementRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onChoiceChange(): void;
    showAll(): void;
}
export declare class EnumFilter implements OnInit, OnDestroy {
    private state;
    private el;
    private viewContainer;
    private resolver;
    filter: ISuperTableFilter;
    column: ColumnState;
    private dropdown;
    private disabledChoices;
    disabledFilterCount: number;
    private subscription;
    constructor(state: SuperTableState, el: ElementRef, viewContainer: ViewContainerRef, resolver: ComponentFactoryResolver);
    ngOnInit(): void;
    ngOnDestroy(): void;
    toggleVisibility(): void;
}
